/****************************************************************************\
*                                                                            *
*  FGFW4.CPP                                                                 *
*  FGFW4U.CPP                                                                *
*                                                                            *
*  Demonstrate manual font loading.                                          *
*                                                                            *
\****************************************************************************/

#include <vcl\vcl.h>
#pragma hdrstop

#include "FGFW4U.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
   fg_realize(hpal);
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   FILE *stream;

   hdc = GetDC(Form1->Handle);
   fg_setdc(hdc);
   hpal = fg_defpal();
   fg_realize(hpal);

   fg_vbinit();
   hvb = fg_vballoc(640,480);
   fg_vbopen(hvb);
   fg_vbcolors();

   stream = fopen("MODERN28.FGF","rb");
   if (stream == NULL)
   {
      Application->MessageBox("Unable to open font file.","Error",MB_ICONSTOP|MB_OK);
      Application->Terminate();
      return;
   }
   fread(font_array,1,FONTSIZE,stream);
   fclose(stream);
   fgf_define(font_array);

   fg_setcolor(255);
   fg_fillpage();

   fg_setcolor(19);
   fg_move(fg_getmaxx()/2,fg_getmaxy()/2);
   fgf_justify(0,0);
   fgf_print("FG/Fonts",8);

   Application->OnActivate = OnActivate;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
   fg_vbscale(0,fg_getmaxx(),0,fg_getmaxy(),0,cxClient-1,0,cyClient-1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
   cxClient = ClientWidth;
   cyClient = ClientHeight;
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   fgf_unload(-1);
   fg_vbclose();
   fg_vbfree(hvb);
   fg_vbfin();
   DeleteObject(hpal);
   ReleaseDC(Form1->Handle,hdc);
}
//---------------------------------------------------------------------------
